
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         netfilterparse
#define yylex           netfilterlex
#define yyerror         netfiltererror
#define yylval          netfilterlval
#define yychar          netfilterchar
#define yydebug         netfilterdebug
#define yynerrs         netfilternerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "./netfilter.y"

/**
 ** @file netfilter.y
 ** Netfilter yaccer.
 **
 ** @author Julien OLIVAIN <julien.olivain@lsv.ens-cachan.fr>
 **
 ** @version 0.1
 ** @ingroup modules
 **
 ** @date  Started on: Mon Jan 27 17:37:12 2003
 **/

/*
 * See end of file for LICENSE and COPYRIGHT informations.
 */


#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <stdlib.h>
#include <stdio.h>

#include <string.h>

/* #include <fcntl.h> */
/* #include <sys/syscall.h> */
/* #include <sys/stat.h> */
#include <netinet/in.h>

  /* #include "netfilter.h" */

#include "orchids.h"

typedef struct string_s string_t;
struct string_s {
  char *str;
  size_t pos;
  size_t len;
};

static ovm_var_t **fields_g;
static char *vstr_base_g;
extern char *netfiltertext;

extern int netfilterlex(void);
extern void netfiltererror(char *s);
void netfilter_set_attrs(ovm_var_t **attr_fields);

static char *ip_proto_g[5];

#define NETFILTER_FIELDS 32
#define F_IN           0
#define F_PHYSIN       1
#define F_OUT          2
#define F_PHYSOUT      3
#define F_MAC          4
#define F_SRC          5
#define F_DST          6
#define F_IPLEN        7
#define F_TOS          8
#define F_PREC         9
#define F_TTL         10
#define F_IPID        11
#define F_IPFLAGS     12
#define F_FRAG        13
#define F_IPOPTS      14
#define F_PROTO       15
#define F_SPT         16
#define F_DPT         17
#define F_SEQ         18
#define F_ACK         19
#define F_WINDOW      20
#define F_RES         21
#define F_TCPFLAGS    22
#define F_URGP        23
#define F_UDPLEN      24
#define F_ICMPTYPE    25
#define F_ICMPCODE    26
#define F_ICMPID      27
#define F_ICMPSEQ     28
#define F_ICMPPARAM   29
#define F_ICMPGATEWAY 30
#define F_ICMPMTU     31

#define IP_PROTO_TCP   0
#define IP_PROTO_UDP   1
#define IP_PROTO_ICMP  2
#define IP_PROTO_OTHER 3

#define IP_FLAG_CE 0x01
#define IP_FLAG_MF 0x02
#define IP_FLAG_DF 0x04

#define TCP_FLAG_CWR 0x01
#define TCP_FLAG_ECE 0x02
#define TCP_FLAG_URG 0x04
#define TCP_FLAG_ACK 0x08
#define TCP_FLAG_PSH 0x10
#define TCP_FLAG_RST 0x20
#define TCP_FLAG_SYN 0x40
#define TCP_FLAG_FIN 0x80



/* Line 189 of yacc.c  */
#line 189 "./netfilter.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NF_IN = 258,
     NF_PHYSIN = 259,
     NF_OUT = 260,
     NF_PHYSOUT = 261,
     NF_MAC = 262,
     NF_SRC = 263,
     NF_DST = 264,
     NF_LEN = 265,
     NF_TOS = 266,
     NF_PREC = 267,
     NF_TTL = 268,
     NF_ID = 269,
     NF_CE = 270,
     NF_DF = 271,
     NF_MF = 272,
     NF_FRAG = 273,
     NF_OPT = 274,
     NF_PROTO = 275,
     NF_INCOMPLETE = 276,
     NF_TCP = 277,
     NF_SPT = 278,
     NF_DPT = 279,
     NF_SEQ = 280,
     NF_ACK = 281,
     NF_WINDOW = 282,
     NF_RES = 283,
     NF_CWR = 284,
     NF_ECE = 285,
     NF_URG = 286,
     NF_PSH = 287,
     NF_RST = 288,
     NF_SYN = 289,
     NF_FIN = 290,
     NF_URGP = 291,
     NF_UDP = 292,
     NF_ICMP = 293,
     NF_TYPE = 294,
     NF_CODE = 295,
     NF_PARAM = 296,
     NF_GATEWAY = 297,
     NF_MTU = 298,
     NF_BYTES = 299,
     STRING = 300,
     INTEGER = 301,
     HEXBYTE = 302,
     INETADDR = 303,
     MACINFO = 304
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 108 "./netfilter.y"

  int integer;
  char *string;
  string_t new_string;
  unsigned int ip_flags;
  unsigned int tcp_flags;
  unsigned char *mac_info;
  struct in_addr ipv4addr;



/* Line 214 of yacc.c  */
#line 286 "./netfilter.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 298 "./netfilter.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   193

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  56
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  34
/* YYNRULES -- Number of rules.  */
#define YYNRULES  66
/* YYNRULES -- Number of states.  */
#define YYNSTATES  217

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   304

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    51,     2,     2,     2,     2,     2,     2,     2,
      52,    53,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    54,     2,    55,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,    47,    48,    50,    51,    56,    57,    62,
      63,    68,    69,    71,    75,    76,    79,    80,    83,    84,
      87,    88,    93,    94,   101,   103,   105,   107,   109,   114,
     126,   153,   154,   163,   172,   173,   176,   177,   180,   181,
     184,   185,   188,   189,   192,   193,   196,   197,   200,   201,
     204,   209,   221,   238,   243,   255,   269,   271,   273,   275,
     277,   286,   291,   296,   301,   302,   307
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      57,     0,    -1,     3,    50,    58,    51,    59,     5,    50,
      58,    51,    60,    61,     8,    50,    48,    51,     9,    50,
      48,    51,    10,    50,    46,    51,    11,    50,    47,    51,
      12,    50,    47,    51,    13,    50,    46,    51,    14,    50,
      46,    51,    63,    67,    68,    69,    -1,    -1,    45,    -1,
      -1,     4,    50,    45,    51,    -1,    -1,     6,    50,    45,
      51,    -1,    -1,     7,    50,    62,    51,    -1,    -1,    49,
      -1,    64,    65,    66,    -1,    -1,    15,    51,    -1,    -1,
      16,    51,    -1,    -1,    17,    51,    -1,    -1,    18,    50,
      46,    51,    -1,    -1,    19,    51,    52,    45,    53,    51,
      -1,    70,    -1,    81,    -1,    82,    -1,    89,    -1,    20,
      50,    22,    51,    -1,    20,    50,    22,    51,    21,    51,
      54,    46,    51,    44,    55,    -1,    20,    50,    22,    51,
      23,    50,    46,    51,    24,    50,    46,    51,    71,    27,
      50,    46,    51,    28,    50,    47,    51,    72,    36,    50,
      46,    51,    -1,    -1,    25,    50,    46,    51,    26,    50,
      46,    51,    -1,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    -1,    29,    51,    -1,    -1,    30,    51,    -1,
      -1,    31,    51,    -1,    -1,    26,    51,    -1,    -1,    32,
      51,    -1,    -1,    33,    51,    -1,    -1,    34,    51,    -1,
      -1,    35,    51,    -1,    20,    50,    37,    51,    -1,    20,
      50,    37,    51,    21,    51,    54,    46,    51,    44,    55,
      -1,    20,    50,    37,    51,    23,    50,    46,    51,    24,
      50,    46,    51,    10,    50,    46,    51,    -1,    20,    50,
      38,    51,    -1,    20,    50,    38,    51,    21,    51,    54,
      46,    51,    44,    55,    -1,    20,    50,    38,    51,    39,
      50,    46,    51,    40,    50,    46,    51,    83,    -1,    84,
      -1,    85,    -1,    86,    -1,    87,    -1,    14,    50,    46,
      51,    25,    50,    46,    51,    -1,    41,    50,    46,    51,
      -1,    42,    50,    48,    51,    -1,    54,    57,    55,    88,
      -1,    -1,    43,    50,    46,    51,    -1,    20,    50,    46,
      51,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   143,   143,   199,   200,   206,   207,   217,   218,   228,
     229,   235,   236,   241,   251,   252,   258,   259,   265,   266,
     272,   273,   282,   283,   288,   292,   296,   300,   310,   311,
     312,   345,   346,   359,   369,   370,   376,   377,   383,   384,
     390,   391,   397,   398,   404,   405,   411,   412,   418,   419,
     428,   429,   430,   450,   451,   452,   466,   467,   468,   469,
     473,   484,   489,   495,   500,   502,   506
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NF_IN", "NF_PHYSIN", "NF_OUT",
  "NF_PHYSOUT", "NF_MAC", "NF_SRC", "NF_DST", "NF_LEN", "NF_TOS",
  "NF_PREC", "NF_TTL", "NF_ID", "NF_CE", "NF_DF", "NF_MF", "NF_FRAG",
  "NF_OPT", "NF_PROTO", "NF_INCOMPLETE", "NF_TCP", "NF_SPT", "NF_DPT",
  "NF_SEQ", "NF_ACK", "NF_WINDOW", "NF_RES", "NF_CWR", "NF_ECE", "NF_URG",
  "NF_PSH", "NF_RST", "NF_SYN", "NF_FIN", "NF_URGP", "NF_UDP", "NF_ICMP",
  "NF_TYPE", "NF_CODE", "NF_PARAM", "NF_GATEWAY", "NF_MTU", "NF_BYTES",
  "STRING", "INTEGER", "HEXBYTE", "INETADDR", "MACINFO", "'='", "' '",
  "'('", "')'", "'['", "']'", "$accept", "nfline", "interface", "physin",
  "physout", "macinfo", "mac_header", "ip_flags",
  "ecn_congestion_experienced", "dont_fragment", "more_fragments",
  "frag_offset", "ip_options", "proto_specifics", "proto_tcp",
  "sequence_numbers", "tcp_flags", "cwr", "ece", "urg", "ack", "psh",
  "rst", "syn", "fin", "proto_udp", "proto_icmp", "icmp_specific",
  "icmp_echo", "icmp_parameter", "icmp_redirect", "icmp_other", "mtu",
  "proto_other", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
      61,    32,    40,    41,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    56,    57,    58,    58,    59,    59,    60,    60,    61,
      61,    62,    62,    63,    64,    64,    65,    65,    66,    66,
      67,    67,    68,    68,    69,    69,    69,    69,    70,    70,
      70,    71,    71,    72,    73,    73,    74,    74,    75,    75,
      76,    76,    77,    77,    78,    78,    79,    79,    80,    80,
      81,    81,    81,    82,    82,    82,    83,    83,    83,    83,
      84,    85,    86,    87,    88,    88,    89
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,    43,     0,     1,     0,     4,     0,     4,     0,
       4,     0,     1,     3,     0,     2,     0,     2,     0,     2,
       0,     4,     0,     6,     1,     1,     1,     1,     4,    11,
      26,     0,     8,     8,     0,     2,     0,     2,     0,     2,
       0,     2,     0,     2,     0,     2,     0,     2,     0,     2,
       4,    11,    16,     4,    11,    13,     1,     1,     1,     1,
       8,     4,     4,     4,     0,     4,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     3,     1,     4,     0,     5,     0,     0,
       0,     0,     0,     3,     6,     0,     7,     0,     9,     0,
       0,     0,     0,    11,     0,     8,    12,     0,     0,    10,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    14,     0,    20,    16,    15,
       0,    22,     0,    18,     0,     0,     0,    17,     0,    13,
       0,     0,     0,     2,    24,    25,    26,    27,    19,    21,
       0,     0,     0,     0,     0,     0,     0,     0,    28,    50,
      53,    66,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
       0,    51,     0,    54,     0,    31,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    55,    56,    57,    58,    59,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    64,     0,     0,    52,     0,    61,    62,
       0,    63,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    65,    32,     0,    60,    34,     0,     0,
      36,    35,     0,     0,    38,     0,    37,     0,    40,     0,
      39,     0,    42,    30,    41,     0,    44,    43,     0,    46,
      45,     0,    48,    47,     0,    33,    49
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     6,     9,    18,    21,    27,    57,    58,    63,
      69,    61,    66,    73,    74,   139,   189,   190,   194,   198,
     202,   206,   209,   212,   215,    75,    76,   145,   146,   147,
     148,   149,   171,    77
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -80
static const yytype_int16 yypact[] =
{
       4,   -42,     9,   -35,   -80,   -80,   -40,     8,   -37,    10,
     -31,   -32,   -30,   -35,   -80,   -29,    13,   -27,    17,   -16,
     -24,    22,   -20,   -15,   -13,   -80,   -80,   -12,   -10,   -80,
      -9,    23,    -7,    -4,    -6,    25,    -3,    -5,    -2,    35,
       0,   -11,     1,    21,     3,     7,     5,    38,    11,     2,
       6,    41,    12,    14,    15,    43,    16,    45,    48,   -80,
      18,    40,    19,    52,    26,    20,    53,   -80,    24,   -80,
      27,    28,    29,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
      31,   -21,    30,    33,    34,    36,    37,    39,   -18,   -17,
     -19,   -80,   -80,    42,    32,    44,    46,    47,    49,    50,
      51,    54,    55,    56,    57,    59,    58,    60,    61,    65,
      62,    63,    67,    64,    68,    66,    76,    74,    69,    77,
      70,    78,    73,    71,    79,    72,    82,    75,    83,   -80,
      80,   -80,    81,   -80,    84,    99,    90,   -14,    86,   106,
      87,    88,    89,    91,     4,   -80,   -80,   -80,   -80,   -80,
      94,    92,    97,    98,   100,   101,    93,    96,   104,   102,
     103,   105,   107,   108,   119,   109,   -80,   127,   -80,   -80,
     111,   -80,   112,   129,   113,   118,   120,   115,   121,   117,
     122,   123,   124,   -80,   -80,   125,   -80,   126,   128,   133,
     141,   -80,   130,   131,   143,   132,   -80,   134,   146,   135,
     -80,   136,   145,   -80,   -80,   137,   148,   -80,   138,   149,
     -80,   139,   156,   -80,   142,   -80,   -80
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -80,   -79,   171,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,   -80,
     -80,   -80,   -80,   -80
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
     141,    83,    97,    93,    95,    94,    96,     1,     3,     4,
       5,     7,     8,    10,    12,    11,    84,    85,    13,    17,
      98,    14,    16,    19,    20,    86,    23,   142,   143,    22,
      24,    25,    32,    44,    26,    36,    42,    28,    30,    29,
     144,    38,    31,    33,    34,    35,    40,    37,    50,    39,
      41,    48,    43,    45,    46,    52,    47,    51,    56,    65,
      54,    49,    53,    60,    62,   156,    55,    59,    64,    68,
      67,    71,    70,    72,     0,    78,    82,     0,    79,    81,
      80,     0,   100,    87,    88,    89,     0,    90,    91,     0,
      92,   118,   120,    99,     0,   101,   102,   106,   103,   104,
     140,   108,     0,   110,   105,   111,   113,     0,   107,   112,
     109,   115,   114,   116,   117,   119,   122,   121,   123,   124,
     126,   125,   127,   128,   138,   130,   129,   131,   132,   134,
     133,   135,   136,   151,     0,   137,   150,   152,   153,   154,
     157,   155,   158,   159,   160,   172,   161,   164,   163,   162,
     165,   170,   174,   166,   167,   188,   168,   177,   169,     0,
     173,   175,   176,   178,   179,   181,   180,   182,   183,   192,
     185,   193,   201,   184,   197,   186,   187,   205,   199,   191,
     195,   208,   196,   211,    15,   200,   203,   204,   207,   210,
     213,   214,     0,   216
};

static const yytype_int16 yycheck[] =
{
      14,    22,    21,    21,    21,    23,    23,     3,    50,     0,
      45,    51,     4,    50,    45,     5,    37,    38,    50,     6,
      39,    51,    51,    50,     7,    46,    50,    41,    42,    45,
       8,    51,     9,    12,    49,    10,    47,    50,    48,    51,
      54,    46,    51,    50,    48,    51,    11,    50,    46,    51,
      50,    13,    51,    50,    47,    14,    51,    51,    15,    19,
      46,    50,    50,    18,    16,   144,    51,    51,    50,    17,
      51,    51,    46,    20,    -1,    51,    45,    -1,    51,    50,
      52,    -1,    50,    53,    51,    51,    -1,    51,    51,    -1,
      51,    24,    24,    51,    -1,    51,    50,    46,    51,    50,
      10,    46,    -1,    46,    54,    46,    46,    -1,    54,    51,
      54,    46,    51,    51,    51,    51,    40,    51,    44,    50,
      50,    44,    44,    50,    25,    46,    55,    55,    46,    46,
      55,    51,    51,    27,    -1,    51,    50,    50,    50,    50,
      46,    50,    50,    46,    46,    26,    46,    51,    55,    48,
      46,    43,    25,    51,    51,    29,    51,    28,    51,    -1,
      51,    50,    50,    50,    46,    50,    46,    46,    51,    36,
      47,    30,    26,    51,    31,    51,    51,    32,    46,    51,
      50,    33,    51,    34,    13,    51,    51,    51,    51,    51,
      51,    35,    -1,    51
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    57,    50,     0,    45,    58,    51,     4,    59,
      50,     5,    45,    50,    51,    58,    51,     6,    60,    50,
       7,    61,    45,    50,     8,    51,    49,    62,    50,    51,
      48,    51,     9,    50,    48,    51,    10,    50,    46,    51,
      11,    50,    47,    51,    12,    50,    47,    51,    13,    50,
      46,    51,    14,    50,    46,    51,    15,    63,    64,    51,
      18,    67,    16,    65,    50,    19,    68,    51,    17,    66,
      46,    51,    20,    69,    70,    81,    82,    89,    51,    51,
      52,    50,    45,    22,    37,    38,    46,    53,    51,    51,
      51,    51,    51,    21,    23,    21,    23,    21,    39,    51,
      50,    51,    50,    51,    50,    54,    46,    54,    46,    54,
      46,    46,    51,    46,    51,    46,    51,    51,    24,    51,
      24,    51,    40,    44,    50,    44,    50,    44,    50,    55,
      46,    55,    46,    55,    46,    51,    51,    51,    25,    71,
      10,    14,    41,    42,    54,    83,    84,    85,    86,    87,
      50,    27,    50,    50,    50,    50,    57,    46,    50,    46,
      46,    46,    48,    55,    51,    46,    51,    51,    51,    51,
      43,    88,    26,    51,    25,    50,    50,    28,    50,    46,
      46,    50,    46,    51,    51,    47,    51,    51,    29,    72,
      73,    51,    36,    30,    74,    50,    51,    31,    75,    46,
      51,    26,    76,    51,    51,    32,    77,    51,    33,    78,
      51,    34,    79,    51,    35,    80,    51
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 156 "./netfilter.y"
    {
      DPRINTF( ("LEN=%i TOS=0x%02X PREC=0x%02X TTL=%i ID=%i\n",
                (yyvsp[(22) - (43)].integer), (yyvsp[(26) - (43)].integer), (yyvsp[(30) - (43)].integer), (yyvsp[(34) - (43)].integer), (yyvsp[(38) - (43)].integer)) );

      if ((yyvsp[(3) - (43)].new_string).len) {
        fields_g[F_IN] = ovm_vstr_new();
        VSTR(fields_g[F_IN]) = vstr_base_g + (yyvsp[(3) - (43)].new_string).pos;
        VSTRLEN(fields_g[F_IN]) = (yyvsp[(3) - (43)].new_string).len;
      }

      if ((yyvsp[(8) - (43)].new_string).len) {
        fields_g[F_OUT] = ovm_vstr_new();
        VSTR(fields_g[F_OUT]) = vstr_base_g + (yyvsp[(8) - (43)].new_string).pos;
        VSTRLEN(fields_g[F_OUT]) = (yyvsp[(8) - (43)].new_string).len;
      }

      fields_g[F_SRC] = ovm_ipv4_new();
      IPV4(fields_g[F_SRC]) = (yyvsp[(14) - (43)].ipv4addr);

      fields_g[F_DST] = ovm_ipv4_new();
      IPV4(fields_g[F_DST]) = (yyvsp[(18) - (43)].ipv4addr);

      fields_g[F_IPLEN] = ovm_int_new();
      INT(fields_g[F_IPLEN]) = (yyvsp[(22) - (43)].integer);

      fields_g[F_TOS] = ovm_int_new();
      INT(fields_g[F_TOS]) = (yyvsp[(26) - (43)].integer);

      fields_g[F_PREC] = ovm_int_new();
      INT(fields_g[F_PREC]) = (yyvsp[(30) - (43)].integer);

      fields_g[F_TTL] = ovm_int_new();
      INT(fields_g[F_TTL]) = (yyvsp[(34) - (43)].integer);

      fields_g[F_IPID] = ovm_int_new();
      INT(fields_g[F_IPID]) = (yyvsp[(38) - (43)].integer);

      DPRINTF( ("*** good line ***\n") );
    ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 199 "./netfilter.y"
    { (yyval.new_string).len = 0; ;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 201 "./netfilter.y"
    { (yyval.new_string) = (yyvsp[(1) - (1)].new_string); ;}
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 206 "./netfilter.y"
    { /* do nothing */ ; ;}
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 208 "./netfilter.y"
    {
      fields_g[F_PHYSIN] = ovm_vstr_new();
      VSTR(fields_g[F_PHYSIN]) = vstr_base_g + (yyvsp[(3) - (4)].new_string).pos;
      VSTRLEN(fields_g[F_PHYSIN]) = (yyvsp[(3) - (4)].new_string).len;
    ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 217 "./netfilter.y"
    { /* do nothing */ ; ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 219 "./netfilter.y"
    {
      fields_g[F_PHYSOUT] = ovm_vstr_new();
      VSTR(fields_g[F_PHYSOUT]) = vstr_base_g + (yyvsp[(3) - (4)].new_string).pos;
      VSTRLEN(fields_g[F_PHYSOUT]) = (yyvsp[(3) - (4)].new_string).len;
    ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 228 "./netfilter.y"
    { DPRINTF( ("no MAC info\n") ); ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 230 "./netfilter.y"
    { DPRINTF( ("MAC=\n") ); ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 235 "./netfilter.y"
    { DPRINTF( ("no MAC header\n") ); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 237 "./netfilter.y"
    { DPRINTF( ("MAC header\n") ); ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 242 "./netfilter.y"
    {
      fields_g[F_IPFLAGS] = ovm_int_new();
      INT( fields_g[F_IPFLAGS] ) = (yyvsp[(1) - (3)].ip_flags) | (yyvsp[(2) - (3)].ip_flags) | (yyvsp[(3) - (3)].ip_flags);
    ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 251 "./netfilter.y"
    { (yyval.ip_flags) = 0; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 253 "./netfilter.y"
    { (yyval.ip_flags) = IP_FLAG_CE; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 258 "./netfilter.y"
    { (yyval.ip_flags) = 0; ;}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 260 "./netfilter.y"
    { (yyval.ip_flags) = IP_FLAG_DF; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 265 "./netfilter.y"
    { (yyval.ip_flags) = 0; ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 267 "./netfilter.y"
    { (yyval.ip_flags) = IP_FLAG_MF; ;}
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 272 "./netfilter.y"
    { /* do nothing */ ; ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 274 "./netfilter.y"
    {
      fields_g[F_FRAG] = ovm_int_new();
      INT(fields_g[F_FRAG]) = (yyvsp[(3) - (4)].integer);
    ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 282 "./netfilter.y"
    { /* do nothing */ ; ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 284 "./netfilter.y"
    { DPRINTF( ("OPT\n") ); ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 289 "./netfilter.y"
    {
      DPRINTF( ("PROTO=TCP\n") );
    ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 293 "./netfilter.y"
    {
      DPRINTF( ("PROTO=UDP\n") );
    ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 297 "./netfilter.y"
    {
      DPRINTF( ("PROTO=ICMP\n") );
    ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 301 "./netfilter.y"
    {
      DPRINTF( ("PROTO=OTHER\n") );
    ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 320 "./netfilter.y"
    {
      DPRINTF( ("SPT=%i DPT=%i WINDOWS=%i URGPP=%i\n", (yyvsp[(7) - (26)].integer), (yyvsp[(11) - (26)].integer), (yyvsp[(16) - (26)].integer), (yyvsp[(25) - (26)].integer)) );
      fields_g[F_PROTO] = ovm_vstr_new();
      VSTR(fields_g[F_PROTO]) = ip_proto_g[IP_PROTO_TCP];
      VSTRLEN(fields_g[F_PROTO]) = strlen(ip_proto_g[IP_PROTO_TCP]);

      fields_g[F_SPT] = ovm_int_new();
      INT(fields_g[F_SPT]) = (yyvsp[(7) - (26)].integer);

      fields_g[F_DPT] = ovm_int_new();
      INT(fields_g[F_DPT]) = (yyvsp[(11) - (26)].integer);

      fields_g[F_WINDOW] = ovm_int_new();
      INT(fields_g[F_WINDOW]) = (yyvsp[(16) - (26)].integer);

      fields_g[F_RES] = ovm_int_new();
      INT(fields_g[F_RES]) = (yyvsp[(20) - (26)].integer);

      fields_g[F_URGP] = ovm_int_new();
      INT(fields_g[F_URGP]) = (yyvsp[(25) - (26)].integer);
    ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 345 "./netfilter.y"
    { /* do nothing */ ; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 347 "./netfilter.y"
    {
      DPRINTF( ("SEQ=%i ACK=%i\n", (yyvsp[(3) - (8)].integer), (yyvsp[(7) - (8)].integer)) );

      fields_g[F_SEQ] = ovm_uint_new();
      UINT(fields_g[F_SEQ]) = (yyvsp[(3) - (8)].integer);

      fields_g[F_ACK] = ovm_uint_new();
      UINT(fields_g[F_ACK]) = (yyvsp[(7) - (8)].integer);
    ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 360 "./netfilter.y"
    {
      fields_g[F_TCPFLAGS] = ovm_int_new();
      INT( fields_g[F_TCPFLAGS] ) = (yyvsp[(1) - (8)].tcp_flags) | (yyvsp[(2) - (8)].tcp_flags) | (yyvsp[(3) - (8)].tcp_flags) | (yyvsp[(4) - (8)].tcp_flags) | (yyvsp[(5) - (8)].tcp_flags) | (yyvsp[(6) - (8)].tcp_flags) | (yyvsp[(7) - (8)].tcp_flags) | (yyvsp[(8) - (8)].tcp_flags);
    ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 369 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 371 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_CWR; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 376 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 378 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_ECE; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 383 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 385 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_URG; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 390 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 392 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_ACK; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 397 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 399 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_PSH; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 404 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 406 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_RST; ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 411 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 413 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_SYN; ;}
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 418 "./netfilter.y"
    { (yyval.tcp_flags) = 0; ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 420 "./netfilter.y"
    { (yyval.tcp_flags) = TCP_FLAG_FIN; ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 433 "./netfilter.y"
    {
      fields_g[F_SPT] = ovm_int_new();
      INT(fields_g[F_SPT]) = (yyvsp[(7) - (16)].integer);

      fields_g[F_DPT] = ovm_int_new();
      INT(fields_g[F_DPT]) = (yyvsp[(11) - (16)].integer);

      fields_g[F_UDPLEN] = ovm_int_new();
      INT(fields_g[F_UDPLEN]) = (yyvsp[(15) - (16)].integer);
    ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 456 "./netfilter.y"
    {
      fields_g[F_ICMPTYPE] = ovm_int_new();
      INT( fields_g[F_ICMPTYPE] ) = (yyvsp[(7) - (13)].integer);

      fields_g[F_ICMPCODE] = ovm_int_new();
      INT( fields_g[F_ICMPCODE] ) = (yyvsp[(11) - (13)].integer);
    ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 474 "./netfilter.y"
    {
      fields_g[F_ICMPID] = ovm_int_new();
      INT( fields_g[F_ICMPID] ) = (yyvsp[(3) - (8)].integer);

      fields_g[F_ICMPSEQ] = ovm_int_new();
      INT( fields_g[F_ICMPSEQ] ) = (yyvsp[(7) - (8)].integer);
    ;}
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 485 "./netfilter.y"
    { DPRINTF( ("PARAMETER\n") ); ;}
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 490 "./netfilter.y"
    { DPRINTF( ("GATEWAY\n") ); ;}
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 497 "./netfilter.y"
    { DPRINTF( ("IP-in-ICMP\n") ); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 507 "./netfilter.y"
    { DPRINTF( ("PROTO=%i\n", (yyvsp[(3) - (4)].integer)) ); ;}
    break;



/* Line 1455 of yacc.c  */
#line 2144 "./netfilter.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 510 "./netfilter.y"


void
netfiltererror(char *s)
{
  DebugLog(DF_MOD, DS_ERROR, "%s at '%s'.\n",
           s, netfiltertext);
}

void
netfilter_set_attrs(ovm_var_t **attr_fields)
{
  fields_g = attr_fields;
}

void
netfilter_set_vstr_base(char *str)
{
  vstr_base_g = str;
}

static char *ip_proto_g[5] = {
  "TCP",
  "UDP",
  "ICMP",
  "OTHER",
  NULL
};


/*
** Copyright (c) 2002-2005 by Julien OLIVAIN, Laboratoire Spcification
** et Vrification (LSV), CNRS UMR 8643 & ENS Cachan.
**
** Julien OLIVAIN <julien.olivain@lsv.ens-cachan.fr>
**
** This software is a computer program whose purpose is to detect intrusions
** in a computer network.
**
** This software is governed by the CeCILL license under French law and
** abiding by the rules of distribution of free software.  You can use,
** modify and/or redistribute the software under the terms of the CeCILL
** license as circulated by CEA, CNRS and INRIA at the following URL
** "http://www.cecill.info".
**
** As a counterpart to the access to the source code and rights to copy,
** modify and redistribute granted by the license, users are provided
** only with a limited warranty and the software's author, the holder of
** the economic rights, and the successive licensors have only limited
** liability.
**
** In this respect, the user's attention is drawn to the risks associated
** with loading, using, modifying and/or developing or reproducing the
** software by the user in light of its specific status of free software,
** that may mean that it is complicated to manipulate, and that also
** therefore means that it is reserved for developers and experienced
** professionals having in-depth computer knowledge. Users are therefore
** encouraged to load and test the software's suitability as regards
** their requirements in conditions enabling the security of their
** systems and/or data to be ensured and, more generally, to use and
** operate it in the same conditions as regards security.
**
** The fact that you are presently reading this means that you have had
** knowledge of the CeCILL license and that you accept its terms.
*/


/* End-of-file */

